<template>
  <div class="reply-message">
    <div class="divider"></div>
    <div class="message">
      <div class="message-details">
        <JText
          color="secondary-title"
          weight="normal"
          type="text-4"
        >
          {{ message.author.name }}
        </JText>
        <JText
          color="third-text"
          weight="normal"
          type="text-4"
          class="ml-2"
        >
          <MessageTime :message="message" />
        </JText>
        <JIcon
          v-if="hideClose === false"
          icon="closeOutline"
          container-size
          size="12px"
          tabindex="0"
          class="close"
          @click="$emit('remove')"
          @keydown.enter="$emit('remove')"
          @keydown.space="$emit('remove')"
        />
      </div>
      <JText
        v-html="message.content"
        tag="div"
        color="secondary-title"
        weight="normal"
        type="text-4"
        class="message-content"
      >
      </JText>
    </div>
  </div>
</template>

<script setup lang="ts">
import { JIcon, JText } from '@new-jira-clone/ui/src/components';
import { PropType } from 'vue';
import { IMessage } from '@/shared';
import MessageTime from './MessageTime.vue';

defineProps({
  message: {
    type: Object as PropType<IMessage>,
    required: true,
  },
  hideClose: {
    type: Boolean,
    default: false,
  },
});

defineEmits<{
  (event: 'remove'): void;
}>();
</script>

<style scoped lang="scss">
@use '@tools' as uiTools;

.reply-message {
  display: flex;
  margin-bottom: 8px;
  padding: 4px;
  min-width: 160px;
  max-width: 460px;
  border-radius: 4px;
  background-color: #fafafa;
  box-shadow: 0 0 2px rgba(0, 0, 0, 0.12), 0 1px 2px rgba(0, 0, 0, 0.14);
}

.divider {
  margin-right: 6px;
  border-left: 1px #c7c7c7 solid;
  border-width: 2px;
  border-radius: 4px;
}

.message {
  width: 100%;
}

.message-details {
  display: flex;
  align-items: center;
  margin-bottom: 3px;
}

.close {
  margin-left: auto;
  cursor: pointer;
  color: rgb(var(--j-secondary-text-color));

  &:hover {
    color: rgb(var(--j-primary-color));
  }

  &:focus-visible {
    outline-offset: 1px;
    outline: var(--j-focus-outline);
  }
}

.message-content {
  @include uiTools.line-clamp(2);
}
</style>
